﻿@using Portal.Models;
@using System.Web.UI.WebControls;
@using DevExpress.Web.Mvc;
@using DevExpress.Web.Mvc.UI;
@using DevExpress.Utils;
@using DevExpress.Web;
@using Toyota.Common.Web.Html.Helper;
@model Toyota.Common.Web.MVC.ModelHolder
@{     
    Layout = "~/Views/Layout/Dashboard.cshtml";
}
<style type="text/css">
#DOC_DATE_FROM_I, #DOC_DATE_TO_I,#DOC_DATE_TO .dxic, #DOC_DATE_FROM .dxic, #INV_NO_I, #INV_TAX_NO_I, #INV_DT_I, #INV_TAX_DT_I, #BASELINE_DT_I, #INV_NO .dxic, #INV_TAX_NO .dxic, #INV_DT .dxic, #INV_TAX_DT .dxic, #BASELINE_DT .dxic{
	background-color:#F6CECE!important;
}

#TAX_AMOUNT_I, #DELIVERY_NO_I, #LogisticPartnerOption_I, #DELIVERY_NO .dxic, #LogisticPartnerOption .dxic, #DLV_COUNT_I, #INV_TAX_AMOUNT_I, #TOTAL_INV_AMOUNT_I, #DLV_COUNT .dxic, #INV_TAX_AMOUNT .dxic, #TOTAL_INV_AMOUNT .dxic #TAX_AMOUNT .dxic{
	background-color:#F5F6CE!important
}
</style>
<script type="text/javascript">

    $(document).ready(function () {
        $('#lbltotalAmount').css("text-align", "right");
        $('#lblSelectedDlvNo').css("text-align", "right");

        $('#UploadProgressDiv').hide();
        GridLogisticPartnerOption.SetHeight(-145);
        gridPopup.SetHeight(155);

         $('#DELIVERY_NO_I').keypress(function(e){
            if(e.keyCode == 8 || e.keyCode == 46 || e.keyCode == 37 || e.keyCode == 38 || e.keyCode == 39 || e.keyCode == 40){
              //console.log(e.keyCode);
            }
            else if(String.fromCharCode(e.which).match(/[^A-Za-z0-9]/)) {
                e.preventDefault();
            }
        });

        $('#INV_NO_I').keypress(function(e){
            if(e.keyCode == 8 || e.keyCode == 46 || e.keyCode == 37 || e.keyCode == 38 || e.keyCode == 39 || e.keyCode == 40){
              //console.log(e.keyCode);
            }
            else if(String.fromCharCode(e.which).match(/[^A-Za-z0-9_/-]/)) {
                e.preventDefault();
            }
        });

         $('#INV_TAX_NO_I').keypress(function(e){
            if(e.keyCode == 8 || e.keyCode == 46 || e.keyCode == 37 || e.keyCode == 38 || e.keyCode == 39 || e.keyCode == 40){
              //console.log(e.keyCode);
            }
//            else if(String.fromCharCode(e.which).match(/[^A-Za-z0-9/-]/)) {
//                e.preventDefault();
//            }
            else if(String.fromCharCode(e.which).match(/[^0-9]/)) {
                e.preventDefault();
            }
        });

         Date.isLeapYear = function (year) {
             return (((year % 4 === 0) && (year % 100 !== 0)) || (year % 400 === 0));
         };

         Date.getDaysInMonth = function (year, month) {
             return [31, (Date.isLeapYear(year) ? 29 : 28), 31, 30, 31, 30, 31, 31, 30, 31, 30, 31][month];
         };

         Date.prototype.isLeapYear = function () {
             return Date.isLeapYear(this.getFullYear());
         };

         Date.prototype.getDaysInMonth = function () {
             return Date.getDaysInMonth(this.getFullYear(), this.getMonth());
         };

         Date.prototype.addMonths = function (value) {
             var n = this.getDate();
             this.setDate(1);
             this.setMonth(this.getMonth() + value);
             this.setDate(Math.min(n, this.getDaysInMonth()));
             return this;
         };


        if (GridDeliveryInvoice.GetSelectedRowCount() == 0 && GridDeliveryInvoice.cpVisibleRow == 0)
        {
            SelectAllCheckBox.SetValue(false);
        }

        GridLogisticPartnerOption.PerformCallback();

        //GridDeliveryInvoice.PerformCallback();
        btnPreview.SetEnabled(true);
        btnClear.SetEnabled(true);
        btnSearch.SetEnabled(true);
        btnUpload.SetEnabled(true);
        ucCallbacks.SetEnabled(true);
        btnDownload.SetEnabled(true);
        btnCancel.SetEnabled(true);

    });

    var ADLV = "";
    var MESSAGE="";
    var DeliveryNo = "";
    var DeliveryNo2 = "";
    var PoNo = "";
    var InvNo = "";
    var PN = "";
    var IN = "";
    var err="";
    var PN2 = "";
    var IN2 = "";
    var TA2 = "";
    var isClear = 0;




    function OnBeginCallbackGrid(s, e) {
        var showUploaded = "";
        e.customArgs["DOC_DATE_FROM"] = DOC_DATE_FROM.GetText();
        e.customArgs["DOC_DATE_TO"] = DOC_DATE_TO.GetText();
        e.customArgs["LP_CD"] = LogisticPartnerOption.GetValue();
        e.customArgs["DELIVERY_NO"] = DELIVERY_NO.GetValue();
        if(cbShow.GetValue()==true)
        {
            showUploaded = "yes";
        }
        else{
            showUploaded = "no";
        }
        //console.log(cbShow.GetValue());
        //console.log(showUploaded);
        e.customArgs["ShowUploaded"] = showUploaded;
        disableButton();

        if (GridDeliveryInvoice.GetSelectedRowCount() == 0 && GridDeliveryInvoice.cpVisibleRow == 0)
        {
            SelectAllCheckBox.SetValue(false);
        }

        countAmount();
    }

    function grid_init(s,e)
    {
        GridDeliveryInvoice.PerformCallback();
    }

    function convertCurr(value){
        var DecimalSeparator = Number("1.2").toLocaleString().substr(1,1);
        var AmountWithCommas = value.toLocaleString();
        var arParts = String(AmountWithCommas).split(DecimalSeparator);
        var intPart = arParts[0];
        var decPart = (arParts.length > 1 ? arParts[1] : '');
        decPart = (decPart + '00').substr(0,2);

        return 'Rp. ' + intPart + DecimalSeparator + decPart;
    }


    function countAmount(){
        var count = GridDeliveryInvoice.GetSelectedRowCount();
        var total = 0;
        var j;
        j = txtGridTemp.GetValue();

        if (j != null){
            j = j.substring(1,j.length - 1);
            j = j.split(";");

            if(count<1)
            {
                $('#lblSelectedDlvNo').html('0');
                $('#lbltotalAmount').html('Rp. 0.00');
            }
            else
            {
                 for(i=0;i<j.length;i++)
                {
                    j[i] = j[i].replace('"','');
                    j[i] = j[i].replace('"','');
                    j[i] = j[i].split("|");
                    total += Number(j[i][1]);
                 }
                 $('#lblSelectedDlvNo').html(j.length);
                 $('#lbltotalAmount').html(convertCurr(total));
                 //lbltotalAmount.textContent = convertCurr(total);
            }
        }
    }


    function OnBeginCallbackPreviewInvoice(s, e) {
        //e.customArgs["DELIVERY_NO"] = DeliveryNo2;
        e.customArgs["PO_NO"] = PoNo;
        e.customArgs["LP_INV_NO"] = DeliveryNo2;
        disableButton();
        
        GridINV_TAX_NO.MoveColumn(0);
        GridTaxCodeCombo.MoveColumn(0);
    }

    var Unchecked = false;
    function SearchData() {
        var result = false;

        if(DOC_DATE_FROM.GetText()!="" || DOC_DATE_TO.GetText()!="")
        {
          if(DOC_DATE_FROM.GetText()!="" && DOC_DATE_TO.GetText()!="")
          {
                if(DOC_DATE_FROM.GetValue() > DOC_DATE_TO.GetValue())
                {
                    $.msgBox({ title: "Warning", type:"alert", content: "FROM date cannot be greater than TO date"});
                }
                else
                {
                    GridDeliveryInvoice.ClearFilter();
                }
          }
          else if(DOC_DATE_FROM.GetText()!="" && DOC_DATE_TO.GetText()=="")
          {
            GridDeliveryInvoice.ClearFilter();
          }
        }
        else
        {
             $.msgBox({ title: "Warning", type:"alert", content: "Please select Document date"});
        }
        //SelectAllCheckBox.SetValue(false);

    }

    function OnEndCallbackGrid(s, e) {
        //$('#lbltotalAmount').html(String.Format("{0:C}", GridDeliveryInvoice.cpTOTAL_AMOUNT));
        //$('#lbltotalAmount').html(convertCurr(GridDeliveryInvoice.cpTOTAL_AMOUNT));
        //$('#lbltotalAmount').html(convertCurr(0));
        //lbltotalAmount.Text = GridDeliveryInvoice.cpTOTAL_AMOUNT;

        enableButton();
        if(isClear==1)
        {
            //SelectAllCheckBox.SetValue(false);
            GridDeliveryInvoice.UnselectAllRowsOnPage();
        }


        if (GridDeliveryInvoice.GetSelectedRowCount() == 0 && GridDeliveryInvoice.cpVisibleRow == 0)
        {
            SelectAllCheckBox.SetValue(false);
        }

        //s.GetSelectedFieldValues(GridDeliveryInvoice.cpKeyfield, GetSelectedFieldValuesCallback);

        countAmount();

        isClear = 0;
    }

    		function SaveInvoice()
    {
			var err = 0;
			var a = INV_NO.GetText();
			var b = INV_TAX_NO.GetText();
			var c = INV_DT.GetText();
			var d = INV_TAX_DT.GetText();
			var e = TaxAmount.GetText();
		    var f = TAX_AMOUNT.GetText();

			var date1 = INV_DT.GetText().substr (3,7);
			var date2 = INV_TAX_DT.GetText().substr (3,7);
            
			var ToleranceVal = ToleranceValue.GetText();
            var BypassFlag = txBypassFlag.GetText();



            //Added by Ark.Taufik
            //var aprlTaxRate = '11';
            //var aprlTaxDate = new Date(2022, 03, 01);
            //if (TaxRateCD.GetValue() == aprlTaxRate) {
            //    if (INV_DT.GetValue() < aprlTaxDate) {
            //        popupPreview.Hide();
            //        $.msgBox({ title: "Warning", content: "Tax Rate 11% only valid from 01 April 2022", afterClose: function () { popupPreview.Show(); } });
            //        return;
            //    }
            //}

			//alert(date1 + " vs "+date2);
			
			var taxvalues = TaxCodeCombo.GetValue();//add riani (20220815)
			if(a=="" || (b=="" && taxvalues !="I0" && taxvalues !="V0") || c=="" || (d=="" && taxvalues !="I0" && taxvalues !="V0")) //edit riani (20220815) -->bypass untuk I0 dan V0 --> before --> if(a=="" || b=="" || c=="" || d=="")
			{
				popupPreview.Hide();
				$.msgBox({ title: "Warning", content: "Please Select fill mandatory", afterClose: function(){popupPreview.Show();} });

			}
			else
			{
				if(a.match(/[^A-Za-z0-9_/-]/)!=null)
				{
					err = 1;
				}

				//if(b.match(/[^A-Za-z0-9_/-]/)!=null)
				if(b.match(/[^0-9]/)!=null)
				{
					err = 1;
				}


				if(err==1)
				{
					popupPreview.Hide();
					$.msgBox({ title: "Warning", content: "Only can be use number or text", afterClose: function(){popupPreview.Show();}});

				}
				else
				{
					var j = JSON.stringify(gridPopup.GetSelectedKeysOnPage());
				    j = j.substring(2, j.length - 2);
					j = j.split('|');
					j = j[1];

					//console.log(j);

                    //MODIFIED BY fid.intan 2015-08-06
				    //Add tolerance value checking
					if (BypassFlag != 'Y' && (Math.abs(e - f) > ToleranceVal)) {
					    //if (e !== f) {
					    popupPreview.Hide();
					    $.msgBox({ title: "Warning", type: "alert", content: "Difference between Tax Amount and Invoice Tax Amount is more than tolerance amount. Please Select Another Tax No", afterClose: function () { popupPreview.Show(); } });
					    //$.msgBox({ title: "Warning", type: "alert", content: "Tax Amount is different with Invoice Tax Amount, Please select another Tax No", afterClose: function () { popupPreview.Show(); } });
					    //}
					}
                    else {
					    $.ajax(
                        {
                            type: "POST",
                            url: "@Url.Content("~/D31401/SaveInvoice")",
                            data:
					        {
					            PO_NO : PN2,
					            LP_INV_NO : INV_NO.GetText(),
					            INV_NO : INV_NO.GetText(),
					            INV_DT : INV_DT.GetText(),
					            INV_TAX_NO : INV_TAX_NO.GetText(),
                                INV_TAX_DT: INV_TAX_DT.GetText(),
                                INV_TAX_CD: TaxCodeCombo.GetValue(), // Created by arka.taufik 2022-03-22 //
                                INV_TAX_RATE: TaxRateCD.GetValue(), // Created by arka.taufik 2022-03-22 //
					            STATUS_CD : '2',
					            DLV_NO : ADLV,
					            LP_INV_NO_GRID : j
					        },
                            success: function (result) {
                                console.log(result);
                                INV_NO.SetText('');
                                INV_DT.SetText('');
                                INV_TAX_NO.SetText('');
                                INV_TAX_DT.SetText('');
                                TOTAL_INV_AMOUNT.SetText('');
                                INV_TAX_AMOUNT.SetText('');
                                DLV_COUNT.SetText('');
                                // popupPreview.Hide();
                                //gridPopup.UnselectAllRowsOnPage();
                                ResetInvoiceTaxForm();
                                GridINV_TAX_NO.UnselectRows();
                                gridPopup.PerformCallback();

                                if (gridPopup.pageRowCount > 1)
                                {
                                    if (result.data[0].TYPE == "WRN") {
                                        popupPreview.Hide();
                                        $.msgBox({ title: "Warning", content: result.data[0].MESSAGE, afterClose: function(){ popupPreview.Show();} });
                                        gridPopup.SelectRowOnPage(1);
                                        console.log("warning 1");
                                    }else{

                                        gridPopup.SelectRowOnPage(0);
                                        console.log("warning 2");
                                    }


                                }
                                else {
                                    popupPreview.Hide();
                                    if (result.data[0].TYPE == "WRN") {
                                        $.msgBox({ title: "Warning", content: result.data[0].MESSAGE });
                                        console.log("warning 3");
                                    }
                                    else {
                                        $.msgBox({ title: "Info", type: "info", content: result.data[0].MESSAGE });
                                        console.log("warning 4");
                                    }
                                    gridPopup.UnselectAllRowsOnPage();
                                    //GridDeliveryInvoice.ClearFilter();
                                    GridDeliveryInvoice.UnselectRows();

                                }

                                $('#lblSelectedDlvNo').html('0');
                                $('#lbltotalAmount').html('Rp. 0.00');

                            }
                        });
					}
				}
				err = 0;

			}
    		    
		}


    function OnEndCallbackPreviewInvoice(s, e) {
        enableButton();
        gridPopup.SelectRowOnPage(0);
    }

    function ClearGrid() {
        var dts = new Date();
        DOC_DATE_FROM.SetValue(new Date(dts.getFullYear(), dts.getMonth(), dts.getDate()-30, 1, 1, 1));
        DOC_DATE_TO.SetText(dts);

        if (GridLogisticPartnerOption.GetVisibleRowsOnPage() != 1) {
            LogisticPartnerOption.SetValue("");
        }

        DELIVERY_NO.SetText("");
        ucCallbacks.ClearText();
        GridDeliveryInvoice.ClearFilter();
        GridLogisticPartnerOption.UnselectAllRowsOnPage();
        //cbShow.SetValue(false);
        GridDeliveryInvoice.UnselectRows();
        isClear = 1;  
                             
        //$('#lblSelectedDlvNo').html('0');
        //$('#lbltotalAmount').html('Rp. 0.00');
    }

    function OnDeliveryNoClick(v) {
        DeliveryNo = v;
        gridmonPopupPRDetail.PerformCallback();
        popupDetail.SetHeaderText('Delivery No : '+v);
        popupDetail.Show();
    }

    function OnBeginCallbackGridDetail(s, e) {
        //e.customArgs["DeliveryNo"] = juju.GetText();
        e.customArgs["DeliveryNo"] = DeliveryNo;

        if (GridDeliveryInvoice.GetSelectedRowCount() == 0 && GridDeliveryInvoice.cpVisibleRow == 0)
        {
            SelectAllCheckBox.SetValue(false);
        }

    }


    function OIPDownloadClick(s, e) {

        var DeliveryNo = "";
        var PoNo= "";
        //var j = GridDeliveryInvoice.GetSelectedKeysOnPage();


        var j = txtGridTemp.GetValue();
        if (j != null){
            //console.log(j);
            j = j.split(';');
            //console.log(j);
        }
        var count = GridDeliveryInvoice.GetSelectedRowCount();

        if(SelectAllCheckBox.GetValue()==true)
        {
            count = 0;
        }

        if(count>0)
        {
           for(i=0;i<count;i++)
           {
               var x = j[i];
                x = x.substring(0,x.length - 1);
                x = x.split('|');
                DeliveryNo += x[0]+",";
		        PoNo += x[2]+",";
           }
        }

         DeliveryNo = DeliveryNo.substring(0,DeliveryNo.length-1);
         PoNo = PoNo.substring(0,PoNo.length-1);
         //console.log(DeliveryNo);

        if(cbShow.GetValue()==true)
        {
            showUploaded = "yes";
        }
        else{
            showUploaded = "no";
        }


        if (DOC_DATE_FROM.GetText() != "" || DOC_DATE_TO.GetText() != "") {
            if (DOC_DATE_FROM.GetText() != "" && DOC_DATE_TO.GetText() != "") {
                if (DOC_DATE_FROM.GetValue() > DOC_DATE_TO.GetValue()) {
                    $.msgBox({ title: "Warning", type: "alert", content: "FROM date cannot be greater than TO date" });
                }
                else {
            $.fileDownload("D31401/DownloadListCSVNew/", {
                data: {
                    DOC_DATE_FROM: DOC_DATE_FROM.GetText(),
                    DOC_DATE_TO: DOC_DATE_TO.GetText(),
                    LP_CD:LogisticPartnerOption.GetValue(),
                    DELIVERY_NO:DELIVERY_NO.GetValue(),
                    DELIVERY_NO2 : DeliveryNo,
                    PO_NO : PoNo,
                    showUploaded : showUploaded
                },
                successCallback: function (url) {
                    //popupProgress.Hide();
                },
                failCallback: function (responseHtml, url) {
                    //popupProgress.Hide();
                    alert(responseHtml);
                }
            });
                }
            }
            else if (DOC_DATE_FROM.GetText() != "" && DOC_DATE_TO.GetText() == "") {
                GridDeliveryInvoice.ClearFilter();
            }
        }
        else {
            $.msgBox({ title: "Warning", type: "alert", content: "Please select Document date" });
        }
        //if (ValidationSearch() == '0') {
            //$("#IPMessageLabel").text("Download in progress,\nPlease wait...");
            //popupProgress.Show();
          //  popupProgress.Hide();
        //}

            //SelectAllCheckBox.SetValue(false);
    }


    function performDownload(){
        $.fileDownload("D31401/DownloadListCSVNew/", {
            data: {
                DOC_DATE_FROM: DOC_DATE_FROM.GetText(),
                DOC_DATE_TO: DOC_DATE_TO.GetText(),
                LP_CD:LogisticPartnerOption.GetValue(),
                DELIVERY_NO:DELIVERY_NO.GetValue(),
                DELIVERY_NO2 : DeliveryNo,
                PO_NO : PoNo,
                showUploaded : showUploaded
            },
            successCallback: function (url) {
                //popupProgress.Hide();
            },
            failCallback: function (responseHtml, url) {
                //popupProgress.Hide();
                alert(responseHtml);
            }
        });

    }

    function InProgressText(fMode) {
            var x = " "
            switch (fMode) {
                case 0:
                    x = "Verification";
                    break;
                case 1:
                    x = "Cancellation";
                    break;
                    defaut:
                    x = "Process";
                    break;
            }
            $('#ProgressDivText').html(x + " in progress");
        }
        var PID="";
    function LivUploadFileUploadComplete(s, e) {

            if (e && e.errorText && e.errorText.length > 1) {
                $('#UploadProgressDiv').hide();
                alert(e.errorText);

                return;
            }

            //checkLock();
            InProgressText(0);
            $('#UploadProgressDiv').show();
            EnableButton();
        }




        var SEQ = 1;
        var lpcount;

    function DoUpload() {

        $.ajax(
        {
          type: "POST",
          url: "@Url.Content("~/D31401/getLP")",
          success: function (resultA) {
              //console.log(resultA);
              if (resultA.Data[0].COUNT > 0) {

                  //-------------
                  $.ajax(
                  {
                      type: "POST",
                      url: "@Url.Content("~/D31401/getProcessStatus")",
                      success: function (resultB) {
                          var stat;
                          if (resultB.Data.length > 0) {
                              stat = resultB.Data[0].PROCESS_STATUS;
                          }
                          else {
                              stat = resultB.Data;
                          }

                          if (stat == "QU4" || stat == "QU3" || stat.length == 0) {
                              //console.log(stat);
                              if (ucCallbacks.GetText() != "") {
                                  ucCallbacks.Upload();
                                  setTimeout(function () {
                                      $.ajax(
                                           {
                                               type: "POST",
                                               url: "@Url.Content("~/D31401/getLastPid")",
                                               success: function (result) {
                                                   //console.log(result);
                                                   PID = result.Data[0].PROCESS_ID;
                                               }
                                           });
                                      UploadProgress();

                                  }, 1000);
                                  disableButton();
                                  //console.log('oioioi');
                                  //InProgressText(0);
                                  $('#UploadProgressDiv .inf').html("");
                              }
                              else {
                                  $.msgBox({ title: "Warning", content: "No file has been selected" });
                              }
                          }
                          else {
                              $.msgBox({ title: "error", type: "error", content: "Another process has been run" });
                          }
                      }
                  });

                  //-------------

              }
          }
        });

        //SelectAllCheckBox.SetValue(false);
  }





  function setError(e) {
      err = e;
  }


  var withError = 0;
  function UploadProgress() {

      if (err != "") {
          $('.dxucErrorCell_IPPCSBlue').hide();
          $.msgBox({ title: "error", type: "error", content: err });
          enableButton();
      }
      else {
          $('#UploadProgressDiv').show();
          //$('#UploadProgressDiv .inf').html(MESSAGE);
          $('#UploadProgressDiv .inf').html('Please wait a moment');
          if (MESSAGE != "Data exist, skipping insert") {
              withError = 1
          }


          //if(MESSAGE == "Please wait a moment")
          //console.log(MESSAGE);
          //if((MESSAGE != "Verifying completed") || (MESSAGE != "Verifiying aborted"))
          if (MESSAGE == "LIV process failed" || MESSAGE == "Verfication completed") {
              if (MESSAGE == "LIV process failed") {
                  $.msgBox({ title: "Warning", content: MESSAGE });
                  GridDeliveryInvoice.UnselectAllRowsOnPage();
              }
              else {
                  $.msgBox({ title: "Info", type: "info", content: MESSAGE });
                  GridDeliveryInvoice.UnselectAllRowsOnPage();
              }
              $('#UploadProgressDiv .inf').html(MESSAGE);
              MESSAGE = "";
              SEQ = 1;
              $('#UploadProgressDiv').fadeOut(300);
              GridDeliveryInvoice.ClearFilter();
              enableButton();
              PID = "";
              withError = 0;

          }
          else {
              $.ajax(
                  {
                      type: "POST",
                      url: "@Url.Content("~/D31401/getProgress")",
                      data:
                      {
                          PID: PID
                      },
                      success: function (result) {
                          var u = result.Data;
                          var MSG = "";
                          if (u.length > 0) {
                              MSG = result.Data[0].MESSAGE;
                          }

                          if (MSG == "LIV process failed" || MSG == "Verfication completed") {
                              MESSAGE = MSG;
                          }
                          else {
                              MESSAGE = "Please wait a moment";
                          }


                          $('#UploadProgressDiv .inf').html(MESSAGE);
                      }
                  });

              window.setTimeout("UploadProgress()", 300);
          }
      }
  }



  function CheckChange(s, e) {
      if (SelectAllCheckBox.GetChecked()) {
          SelectAllCheckBox.SetValue(true);
          GridDeliveryInvoice.SelectRows();
      }
      else {
          GridDeliveryInvoice.UnselectRows();
      }

      var count = GridDeliveryInvoice.GetSelectedRowCount();
      //console.log(count);
      if (count < 1) {
          $('#lblSelectedDlvNo').html('0');
          $('#lbltotalAmount').html(convertCurr(0));
      }
      else {
          /* for(i=0;i<j.length;i++)
           {
              j[i] = j[i].replace('"','');
              j[i] = j[i].replace('"','');
              j[i] = j[i].split("|");
              total += Number(j[i][1]);
           }
           $('#lblSelectedDlvNo').html(j.length);
           $('#lbltotalAmount').html(convertCurr(total));*/
      }
  }

  function GridDeliveryInvoice_SelectionChange(s, e) {

      if (GridDeliveryInvoice.GetSelectedRowCount() == GridDeliveryInvoice.cpVisibleRow) {
          SelectAllCheckBox.SetValue(true);
      }
      else {
          SelectAllCheckBox.SetValue(false);
      }

      s.GetSelectedFieldValues(GridDeliveryInvoice.cpKeyfield, GetSelectedFieldValuesCallback);

  }

  function GetSelectedItemsText(items) {
      var texts = [];
      var textSeparator = ";";
      for (var i = 0; i < items.length; i++) {
          if (items[i] != '') {
              texts.push(items[i].trim());
          }
      }

      txtGridTemp.SetValue(texts.join(textSeparator));

      //console.log(texts.join(textSeparator));
  }

  function GetSelectedFieldValuesCallback(values) {
      GetSelectedItemsText(values);
      countAmount();
      //console.log(values);
  }

  var d = 0;

  function PreviewInvoice(s, e) {
      if (GridDeliveryInvoice.GetSelectedRowCount() != 0) {
          var j = txtGridTemp.GetValue();
          //console.log(j);
          j = j.split(';');

          var t;

          $.ajax(
            {
                type: "POST",
                url: "@Url.Content("~/D31401/GetInvoiceDateRange")",
                data: {},
                async:false,
                  success: function (result) {
                    d = Number(result);
                    var max = new Date().addMonths(d);
                    var min = new Date().addMonths(-d);
                    INV_DT.SetMaxDate(new Date(max.getFullYear(), max.getMonth(), 1));
                    INV_DT.SetMinDate(new Date(min.getFullYear(), min.getMonth(), 1));
                    ToleranceValue.SetText(1000000)
                },
                error: function (result) {
                    
                }
            });

          popupPreview.Show();

          DeliveryNo2 = "";
          InvNo = "";
          PoNo = "";
          //            var j = JSON.stringify(GridDeliveryInvoice.GetSelectedKeysOnPage());
          //            j = j.substring(1,j.length - 1);
          //            j = j.replace(/\b'"'\b/gi, '');
          //            j = j.split(',');

          for (i = 0; i < j.length; i++) {
              j[i] = j[i].split('|');
              j[i][0] = j[i][0].substring(0, j[i][0].length);
              j[i][3] = j[i][3].substring(0, j[i][3].length - 1);
              j[i][2] = j[i][2].substring(0, j[i][2].length);
              if (j[i][3] != "") {
                  InvNo += j[i][3] + ",";
              }

              if (j[i][2] != "") {
                  PoNo += j[i][2] + ",";
              }

              if (j[i][0] != "") {
                  DeliveryNo2 += j[i][0] + ",";
              }
              IN = j[i][3];
              PN = j[i][2];

          }
          //console.log(InvNo.length);

          InvNo = InvNo.substring(0, InvNo.length - 1);

          PoNo = PoNo.substring(0, PoNo.length - 1);
          DeliveryNo2 = DeliveryNo2.substring(0, DeliveryNo2.length - 1);
          //console.log("DELIVERY_NO2 " + DeliveryNo2);
          /*t = InvNo;
          t = t.split(',');
          if(t[0]=="")
          {
              InvNo = "";
          }*/
          //console.log(PoNo);
          //console.log(DeliveryNo2);
          //console.log(InvNo);
          //console.log(DeliveryNo2);

          ResetInvoiceTaxForm();
          GridINV_TAX_NO.UnselectRows();
          GridINV_TAX_NO.MoveColumn(0);

          gridPopup.PerformCallback();

          GridTaxCodeCombo.MoveColumn(0); // Created by arka.taufik 2022-03-22 //
      }
      else {
          $.msgBox({ title: "Warning", content: "Please select one data" });
      }
  }

  function RowSelect2(s, e) {


      var x = JSON.stringify(gridPopup.GetSelectedKeysOnPage());

      x = x.substring(2, x.length - 2);
      x = x.split('|');
      if (e.isSelected == true) {
          $.ajax(
              {
                  type: "POST",
                  url: "@Url.Content("~/D31401/getTotalAmount")",
                  data:
                  {
                      PO_NO: x[0],
                      LP_INV_NO: x[1],
                      DeliveryNo: DeliveryNo2
                  },
                  success: function (result) {

                      //console.log(result)

                      PN2 = x[0];
                      IN2 = x[1];
                      TA = x[2]
                      if (x[1] == "[]") {
                          x[1] = "";
                      }
                      INV_NO.SetText(x[1]);
                      if (INV_NO.GetText() == "") {
                          INV_NO.SetEnabled(true);
                      }
                      else {
                          INV_NO.SetEnabled(false);
                      }
                      INV_DT.SetText("");
                      TOTAL_INV_AMOUNT.SetText(result.Data[0].TOTAL);

                      DLV_COUNT.SetText(result.Data[0].DLV_COUNT);
                      INV_TAX_AMOUNT.SetText(result.Data[0].TAX_AMT);
                      TAX_AMOUNT.SetText(result.Data[0].TAX);

                      TaxCodeCombo.SetValue(result.Data[0].TAX_CD); // Created by arka.taufik 2022-03-22 //
                      GridTaxCodeCombo.SelectRowsByKey(result.Data[0].TAX_CD) // Created by arka.taufik 2022-03-22 //
                      TaxRateCD.SetValue(parseFloat(result.Data[0].TAX_RATE.replaceAll(',', '.')) * 100) // Created by arka.taufik 2022-03-22 //

                      /*  if(result.Data[0].LP_INV_NO!="")
                        {
                            INV_NO.SetEnabled(false);
                        }
                        else{
                             INV_NO.SetEnabled(true);
                        }
                        */
                      //INV_NO.SetText(result.Data[0].LP_INV_NO);
                      INV_NO.SetText(x[1]);
                      /*if(result.Data[0].INV_DT!="")
                      {
                        INV_DT.SetEnabled(false);
                      }
                      else
                      {
                       INV_DT.SetEnabled(true);
                      }
                      */
                      //INV_DT.SetText(result.Data[0].INV_DT);
                      INV_DT.SetValue(new Date(result.Data[0].INV_DT));
                      /*
                      if(result.Data[0].INV_TEXT !="")
                      {
                       INV_TAX_NO.SetEnabled(false);
                      }
                      else
                      {
                       INV_TAX_NO.SetEnabled(true);
                      }
                      */
                      INV_TAX_NO.SetText('');
                      /*
                      if(result.Data[0].INV_TAX_DT != "")
                      {
                           INV_TAX_DT.SetEnabled(false);
                      }
                      else
                      {
                        INV_TAX_DT.SetEnabled(true);
                      }
                      */
                      //INV_TAX_DT.SetText(result.Data[0].INV_TAX_DT);
                      //INV_TAX_DT.SetValue(new Date(result.Data[0].INV_TAX_DT));
                      ADLV = result.Data[0].DLV_NO;
                      //console.log(ADLV);
                  }
              });

          //ADDED BY fid.intan 2015-08-06
          //Get Tolerance value for tax amount - invoice tax amount
          $.ajax({
              type: "POST",
              url: "@Url.Content("~/D31401/GetToleranceVal")", data: {},
                    success: function (result) {
                        ToleranceValue.SetText(result);
                        TaxAmount.SetText("");

                    },
                    error: function (result) { }
          });
      }
  }

    function INV_TAX_NORowClick(s, e) {
        //Modified by fid.intan 2015-08-10
        s.GetSelectedFieldValues("InvoiceTaxDate", function (field) {
            HidTaxDate.SetValue(new Date(field));
            INV_TAX_DT.SetValue(HidTaxDate.GetText());
        });

        s.GetSelectedFieldValues("InvoiceTax", function (field) {
            HidTaxAmount.SetValue(Number(field));
            TaxAmount.SetValue(Number(field));
        });

        s.GetSelectedFieldValues("BypassFlag", function (field) {
            txBypassFlag.SetValue(field);
        });
    }

    $(document).ready(function() {
        $(document).on("click", "#btnOkINV_TAX_NO", function(e) {
            INV_TAX_DT.SetValue(HidTaxDate.GetText());
            TaxAmount.SetValue(Number(HidTaxAmount.GetValue()));
        });

        $(document).on("click", "#btnCancelINV_TAX_NO", ResetInvoiceTaxForm);
    });

    function ResetInvoiceTaxForm() {
        INV_TAX_NO.SetValue("");
        INV_TAX_DT.SetValue(null);
        TaxAmount.SetValue("");

        HidTaxDate.SetValue(null);
        HidTaxAmount.SetValue("");
    }

  function DownloadDetail(s, e) {
      //console.log("ADLV: "+ADLV);
      var j = JSON.stringify(gridPopup.GetSelectedKeysOnPage());
      if (j == "[]") {
          //alert("Please Select Status");
          popupPreview.Hide();
          $.msgBox({ title: "Warning", content: "Please Select invoice" });
      }
      else {
          j = j.split("|");
          j = j[1];
          j = j.substring(0, j.length - 2);
          
          $.ajax(
            {
                type: "POST",
                url: "@Url.Content("~/D31401/exportToExcel")",
                data:
                {
                    LP_INV_NO : j,
                    DLV_NO: ADLV
                },
                success: function (result) {
                    if (result.count > 0) {
                        var link = "@Url.Content("~/")" + result.excelLink;
                        window.location = link;
                        popupPreview.Hide();
                    }
                    else {
                        popupPreview.Hide();
                        $.msgBox({ title: "error", type: "error", content: "Failed to download data" });
                    }

                },
                error: function (result) {
                    $.msgBox({ title: "error", type: "error", content: "Could not download file" });
                }
            });
      }
  }


  function closePopup(s, e) {
      INV_NO.SetText('');
      INV_DT.SetText('');
      INV_TAX_NO.SetText('');
      INV_TAX_DT.SetText('');
      TOTAL_INV_AMOUNT.SetText('');
      INV_TAX_AMOUNT.SetText('');
      DLV_COUNT.SetText('');
      popupPreview.Hide();
      gridPopup.UnselectAllRowsOnPage();
      //GridDeliveryInvoice.ClearFilter();
      GridDeliveryInvoice.UnselectRows();
  }


  function cancel(s, e) {

      $.msgBox(
          {
              title: "Confirmation",
              type: "confirm",
              content: "Are you sure want to do this?",
              buttons: [
                  { value: "Yes" },
                  { value: "No" }
              ],
              success: function (res) {
                  if (res == "Yes") {
                      $.ajax(
                      {
                          type: "POST",
                          url: "@Url.Content("~/D31401/getLP")",
                          success: function (result) {
                              if (result.Data[0].COUNT > 0) {
                                  DeliveryNo = "";
                                  var j = JSON.stringify(GridDeliveryInvoice.GetSelectedKeysOnPage());
                                  j = j.replace('"', '');
                                  j = j.replace('[', '');
                                  j = j.split(',');

                                  for (i = 0; i < j.length; i++) {
                                      j[i] = j[i].split('|');
                                      j[i][0] = j[i][0].replace('"', '');
                                      DeliveryNo += j[i][0] + ',';
                                  }
                                  DeliveryNo = DeliveryNo.substring(0, DeliveryNo.length - 1);

                                  //console.log(DeliveryNo);
                                  if (DeliveryNo != "]") {
                                      $.ajax(
                                      {
                                          type: "POST",
                                          url: "@Url.Content("~/D31401/cancel")",
                                          data:
                                          {
                                              DeliveryNo: DeliveryNo
                                          },
                                          success: function (result) {
                                              //console.log(result);
                                              if (result.data[0].TYPE == "WRN") {
                                                  $.msgBox({ title: "error", type: "error", content: result.data[0].MESSAGE });
                                              }
                                              else {
                                                  $.msgBox({ title: "info", type: "info", content: result.data[0].MESSAGE });
                                              }

                                              GridDeliveryInvoice.ClearFilter();
                                              GridDeliveryInvoice.UnselectAllRowsOnPage();
                                              $('#lblSelectedDlvNo').html('0');
                                              $('#lbltotalAmount').html('Rp. 0.00');
                                          }
                                      });
                                  }
                                  else {
                                      $.msgBox({ title: "Warning", content: "Please select data to be cancel" });
                                  }

                                  DeliveryNo = "";
                                  //SelectAllCheckBox.SetValue(false);

                              }
                              else {
                                  $.msgBox({ title: "Error", type: 'error', content: "You are not authorized to do this action" });
                              }
                          }
                      });
                  }
              }
          });

  }


  function disableButton() {
      btnPreview.SetEnabled(false);
      btnClear.SetEnabled(false);
      btnSearch.SetEnabled(false);
      btnUpload.SetEnabled(false);
      ucCallbacks.SetEnabled(false);
      btnDownload.SetEnabled(false);
      btnCancel.SetEnabled(false);
  }

  function enableButton() {
      btnPreview.SetEnabled(true);
      btnClear.SetEnabled(true);
      btnSearch.SetEnabled(true);
      btnUpload.SetEnabled(true);
      ucCallbacks.SetEnabled(true);
      btnDownload.SetEnabled(true);
      btnCancel.SetEnabled(true);
  }

    // Created by arka.taufik 2022-03-22 //
    function GetTaxCodeCombo(a, b, c) {
        a.GetSelectedFieldValues("RATE", function (field) {
            TaxRateCD.SetValue(parseInt(field));
            TAX_AMOUNT.SetValue((parseInt(TOTAL_INV_AMOUNT.GetValue()) * parseInt(field)) / 100);
            INV_TAX_AMOUNT.SetValue(parseInt(TOTAL_INV_AMOUNT.GetValue()) + parseInt(TAX_AMOUNT.GetValue()));
        });
    }

</script>
    <table border="0">
        <tr>

           @*Button*@
            <td style="width:850px;">
                <div style="display: table; border: 1px solid #002D96; background-color: #DEECFD; padding: 10px; width:830px; margin-right: 10px;">
                    @Html.Action("PartialHeader", "D31401")
                </div>
            </td>

            <td valign="top" style="width:325px;">
                <div style="display: table; border: 1px solid #002D96; background-color: #DEECFD; padding: 10px; width: 300px; margin-right: 10px;">
                    <table>
                        <tr>
                            <td style="width:150px">Selected Delivery No</td>
                            <td style="text-align:right;" width="150">
                                @Html.DevExpress().Label(
                                label =>
                                {
                                    label.Name = "lblSelectedDlvNo";
                                    label.Text = "0";
                                    label.ClientVisible = true;
                                    label.Properties.Style.HorizontalAlign = HorizontalAlign.Right;
                                    label.Properties.DisplayFormatString = "#,##0";
                                    
                                }).GetHtml()
                            </td>
                        </tr>
                        <tr>
                            <td>Total Amount</td>
                            <td style="text-align:right;">
                                @Html.DevExpress().Label(
                                label =>
                                {
                                    label.Name = "lbltotalAmount";
                                    label.Text = "Rp. 0.00";
                                    label.ClientVisible = true;
                                    
                                    label.Properties.Style.HorizontalAlign = HorizontalAlign.Right;
                                    label.Properties.DisplayFormatString = "#,##0";
                                }).GetHtml()
                            </td>
                        </tr>
                    </table>
                </div>

                <div id="UploadProgressDiv" style="display: table; border: 1px solid #002D96; background-color: #ffcc00; padding: 10px; width: 250px; margin-right: 10px; margin-top:10px; height:42px;">
                    <table>
                        <tbody><tr>
                            <td style="width:250px">Verifiying</td>
                            <td style="text-align:right;">
                               
                            </td>
                        </tr>
                        <tr>
                            <td coslpan="2"><span class="inf"></span></td>
                        </tr>
                    </tbody></table>
                </div>

                
            </td>
        </tr>
    </table>


    @*<div style="
    display: table; border: 1px solid #002D96; background-color: #DEECFD;
        padding: 10px; width:900px; margin-right: 10px;">
        @Html.Action("PartialHeader", "D31401")
    </div>*@





<div style="height: 10px;">

</div>


@* div spacing *@ @* style="width:1340px"*@
@*<div style="
display: table; border: 1px solid #002D96; background-color: #DEECFD;
    padding: 10px; width: 1310px; margin-right: 10px;">*@
    <div style=" display: table; width: 1200px; margin-right: 10px;">
    @Html.Action("PartialListData", "D31401")


</div>

@Html.DevExpress().TextBox(
label =>
{
    label.Name = "txtGridTemp";
    label.ClientVisible = false;
    //label.Width = 800;
    //label.Height = 300;

}).GetHtml()



@Html.DevExpress().PopupControl(settings =>
{
    settings.Name = "popupDetail";
    settings.HeaderText = " Delivery No :";
    settings.Width = Unit.Pixel(700);
    settings.Height = Unit.Pixel(170);
    //settings.Width = System.Web.UI.WebControls.Unit.Percentage(40);
    //settings.Height = System.Web.UI.WebControls.Unit.Percentage(100);
    settings.Modal = true;
    settings.ShowCloseButton = false;
    //settings.Top = 35;
    //settings.CloseAction = CloseAction.CloseButton;
    settings.PopupHorizontalAlign = PopupHorizontalAlign.WindowCenter;
    settings.PopupVerticalAlign = PopupVerticalAlign.WindowCenter;
    //settings.DragElement = DragElement.Window;
    //settings.ShowHeader = false;
    settings.SetContent(() =>
    {
        Html.RenderPartial("popupDetailCreation");
    });
}).GetHtml()

@Html.DevExpress().PopupControl(settings =>
{
    settings.Name = "popupPreview";
    settings.HeaderText = "Invoice Preview";
    settings.Width = System.Web.UI.WebControls.Unit.Pixel(850);
    //settings.Width = System.Web.UI.WebControls.Unit.Percentage(40);
    //settings.Height = System.Web.UI.WebControls.Unit.Percentage(100);
    settings.Modal = true;
    settings.ShowCloseButton = false;
    //settings.Top = 35;
    settings.CloseAction = CloseAction.CloseButton;
    settings.PopupHorizontalAlign = PopupHorizontalAlign.WindowCenter;
    settings.PopupVerticalAlign = PopupVerticalAlign.WindowCenter;
    //settings.DragElement = DragElement.Window;
    //settings.ShowHeader = false;
    settings.SetContent(() =>
    {
        Html.RenderPartial("popupPreviewLayout");
    });
}).GetHtml()


@*MESSAGE BOX*@
@Html.Action("MessageBox", "D31401")